﻿using System;
using System.Linq;
using System.ComponentModel;
using System.Globalization;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Collections.Generic;
using System.Windows;

namespace WpfPropertyDetail
{
    public partial class Page1 : Page
    {
        public Page1()
        {
            InitializeComponent();
        }

        private readonly BindingList<MyData> _myDataList = new BindingList<MyData>();
        public BindingList<MyData> MyDataList
        {
            get
            {
                return _myDataList;
            }
        }
    }

    [ValueConversion(typeof(SolidColorBrush), typeof(SolidColorBrush))]
    internal class BackToFrontColorConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value != null)
            {
                Color backgroundColor = ((SolidColorBrush)value).Color;
                const int nThreshold = 120;
                int bgDelta = System.Convert.ToInt32((backgroundColor.R * 0.299) + (backgroundColor.G * 0.587) + (backgroundColor.B * 0.114));

                if (255 - bgDelta < nThreshold)
                {
                    return Brushes.Black;
                }
            }

            return Brushes.White;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}